]> git.sesse.net Git - backup.sh/commitdiff
Unify logging a bit.
authorSteinar H. Gunderson <sesse@samfundet.no>
Sun, 5 Oct 2014 17:54:42 +0000 (19:54 +0200)
committerSteinar H. Gunderson <sesse@samfundet.no>
Sun, 5 Oct 2014 17:54:42 +0000 (19:54 +0200)
backup.sh

index e6735c3fd94854d32997812978cef5f20bf859c1..961c0c2ea88c7ae391a3a3d1e8936576ca9ecd9b 100755 (executable)
--- a/backup.sh
+++ b/backup.sh
@@ -44,36 +44,39 @@ fi
 
 # Die more or less gracefully (at least notify user)
 die() {
-       echo `date`": Something nasty happened."
+       warnmsg "Aborting."
        rm $LOCKFILE
        exit 1
 }
 diemsg() {
-       echo `date`": $computer: $@"
+       warnmsg "$@"
        die
 }
+warnmsg() {
+       echo `date`": $computer: $@"
+       echo `date`": $computer: $@" >&2
+}
+infomsg() {
+       echo `date`": $computer: $@" >&2
+}
 
 # Trap C-c and kill
 trap die SIGINT SIGTERM
 
 # Don't start if we're already running
 if [ -e $LOCKFILE ]; then
-       echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
-       echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
-       exit 1
+       diemsg "$LOCKFILE exists for pid `cat $LOCKFILE`."
 fi;
 touch $LOCKFILE
 echo $$ > $LOCKFILE
 
-echo `date`": Backup run starting" >&2
+infomsg "Backup run starting"
 
 umask 027
 
-
 backup()
 {
-       echo -n `date` >&2
-       printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
+       infomsg "$computer:$filesystem $backuplevel backup\n"
 
        SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
        incrementalsnar="/root/.backup/${sfilesystem}.snar"
@@ -86,7 +89,7 @@ backup()
                        fi
                        lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
                else
-                       echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
+                       infomsg "Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup"
                        incrementalsnar=""
                        lastd=`cat ../.date`
                        lastcmd="--newer='$lastd'"
@@ -108,7 +111,7 @@ backup()
        TARFILE=$DATE.tmp
        TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
                --exclude-from=/root/.backup/exclude\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
-       echo `date`" $computer: Running $TARCMD" >&2
+       infomsg "Running $TARCMD"
        eval $TARCMD > $DATE.idx
 
        if [ $? -eq 0 ] && [ -s $TARFILE ]; then
@@ -148,15 +151,15 @@ backup()
 # Check that the target filesystem is mounted (actually check that it's not
 # the root filesystem)
 if [ ! -d "$storagedir/$computer" ]; then
-       diemsg "Target filesystem ($storagedir/$computer) does not exist. Aborting"
+       diemsg "Target filesystem ($storagedir/$computer) does not exist."
 fi
 rootfilesystem=`df -P /`
 targetfilesystem=`df -P "$storagedir/$computer"`
 if [ "$rootfilesystem" == "$targetfilesystem" ]; then
-       diemsg "Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
+       diemsg "Target filesystem ($storagedir/$computer) was mounted on /."
 fi
 
-echo `date`" $computer: Backing up $computer" >&2
+infomsg "Backing up $computer"
 
 # Try to SSH to the computer without entering a password.
 if ! ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true; then
@@ -167,7 +170,7 @@ fi
 if ssh -n root@$computer "pigz -V 2>/dev/null"; then
        compressor=pigz
 else
-       echo `date`" $computer: pigz missing; falling back to gzip."
+       infomsg "pigz missing; falling back to gzip."
        compressor=gzip
 fi
 
@@ -258,7 +261,7 @@ for filesystem in $filesystems; do
        # Delete old full backups
        for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`; do
                prefix=`echo $full | sed "s/\.[^.]*$//"`
-               echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
+               infomsg "$computer:$filesystem Deleting full backup $prefix"
                rm $prefix*
        done
 
@@ -276,9 +279,9 @@ done
 if ! ssh root@$computer "[ ! -f /root/.backup/postexec ] || /bin/bash -x /root/.backup/postexec" >&2; then
        diemsg "Could not run $computer:/root/.backup/postexec"
 fi
-       
-echo `date`": $computer: Backup completed successfully."
-echo `date`": $computer: Backup completed successfully." >&2
+
+# Use warn so that we will get an email even on success.
+warnmsg "$computer: Backup completed successfully."
 
 # Remove lockfile
 rm $LOCKFILE